<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey H.M. Taylor}
 * @copyright Onpub (TM). Copyright 2010, Onpub Co..
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 */
class OnpubViewArticle
{
  private $pdo;
  private $ID;

  function __construct(PDO $pdo, $ID)
  {
    $this->pdo = $pdo;
    $this->ID = $ID;
  }

  public function display()
  {
    $oarticles = new OnpubArticles($this->pdo);
    $osections = new OnpubSections($this->pdo);
    $owebsites = new OnpubWebsites($this->pdo);
    $osamaps = new OnpubSAMaps($this->pdo);

    $queryOptions = new OnpubQueryOptions();
    $queryOptions->includeAuthors = TRUE;
    $article = $oarticles->get($this->ID, $queryOptions);
    $created = $article->getCreated();
    $modified = $article->getModified();
    $authors = $article->authors;
    $websites = $owebsites->select(new OnpubQueryOptions());
    $websitesassoc = array ();
    $queryOptions = new OnpubQueryOptions();
    $samaps = $osamaps->select($queryOptions, NULL, $this->ID);
    $sections = array ();

    foreach ($samaps as $samap) {
      $sections[] = $osections->get($samap->sectionID);
    }

    foreach ($websites as $website) {
      $ID = $website->ID;
      $websitesassoc["$ID"] = $website;
    }

    if ($article->imageID) {
      $image = $article->image;
    }

    $widget = new OnpubWidgetHeader("Article - " . $article->title);
    $widget->display();

    en('<b>ID</b><br>' . $article->ID, 1, 2);

    en('<b>Created</b><br>' . $created->format('M j, Y g:i:s A'), 1, 2);

    en('<b>Modified</b><br>' . $modified->format('M j, Y g:i:s A'), 1, 2);

    if (sizeof($sections)) {
      en('<b>');

      if (sizeof($sections) == 1) {
        en('Section ');
      }
      elseif (sizeof($sections) > 1) {
        en('Sections ');
      }
      else {
      // no sections
      }

      en('</b><br>');

      for ($i = 0; $i < sizeof($sections); $i++) {
        $sectionWebsiteID = $sections[$i]->websiteID;

        if ($i + 1 == sizeof($sections)) {
          en('<a href="index.php?onpub=EditSection&amp;ID=' . $sections[$i]->ID . '" title="Edit">' . $sections[$i]->name . '</a> Website: <a href="index.php?onpub=EditWebsite&amp;ID='
            . $sections[$i]->websiteID . '" title="Edit">'
            . $websitesassoc["$sectionWebsiteID"]->name . '</a>', 1, 2);
        }
        else {
          en('<a href="index.php?onpub=EditSection&amp;ID=' . $sections[$i]->ID . '" title="Edit">' . $sections[$i]->name . '</a> Website: <a href="index.php?onpub=EditWebsite&amp;ID='
            . $sections[$i]->websiteID . '" title="Edit">'
            . $websitesassoc["$sectionWebsiteID"]->name . '</a>', 1, 1);
        }
      }
    }

    if ($article->url) {
      en('<b>URL</b><br><a href="' . $article->url . '" target="_blank" title="Go">' . $article->url . '</a>', 1, 2);
    }

    en('<b>Title</b><br><a href="index.php?onpub=EditArticle&amp;ID='
      . $article->ID . '" title="Edit">' . $article->title . '</a>');

    if (sizeof($authors)) {
      en('<b>');

      if (sizeof($authors) == 1) {
        en('Author ');
      }
      elseif (sizeof($authors) > 1) {
        en('Aritcle Authors ');
      }
      else {
      // no authors
      }

      en('</b><br>');

      for ($i = 0; $i < sizeof($authors); $i++) {
        if ($i + 1 == sizeof($authors)) {
          echo $authors[$i]->displayAs;
        }
        else {
          echo $authors[$i]->displayAs . '<br>';
        }
      }
    }

    en('<hr>');

    echo $article->content . "\n";

    br();

    en('<hr>');

    if ($article->imageID) {
      en('<b>Image</b><br>');

      $image = $article->image;
      $imageWebsiteID = $image->websiteID;
      $website = $websitesassoc["$imageWebsiteID"];

      if (file_exists($website->imagesDirectory . $image->fileName)) {
        $imageDimensions = getimagesize($website->imagesDirectory . $image->fileName);

        $imageWidth = $imageDimensions[0];
        $imageHeight = $imageDimensions[1];
      }
      else {
        $imageWidth = "";
        $imageHeight = "";
      }

      if (@fopen(addTrailingSlash($website->imagesURL) . $image->fileName, 'r')) {
        en('<a href="index.php?onpub=EditImage&amp;ID=' . $image->ID . '"><img src="' . addTrailingSlash($website->imagesURL) . $image->fileName . '" width="' . $imageWidth . '" height="'
          . $imageHeight . '" alt="Edit" title="Edit" border="0"></a>');
      }
      else {
        en('<span class="error">Can\'t display ' . $image->fileName . ', make sure <a href="index.php?onpub=EditWebsite&amp;ID='
          . $website->ID . '" title="Edit">' . $website->name . '</a>\'s <b>Images URL</b> is setup correctly.</span>');
      }
    }

    $widget = new OnpubWidgetFooter();
    $widget->display();
  }
}
?>